!- -----------------------------------------------------------------------------
!- Basic Text Game Engine
!- Programed by Petr Chlud 2017 - 2019
!- Herni engine umoznujici vytvareni a hrani textovych her na zaklade
!- definovani promennych a poli
!- -----------------------------------------------------------------------------

!- nacteni promennych a komnat

10 GOSUB 2840
20 GOSUB 3420

!- zadani jmena a uvodni obrazovka hry

30 GOSUB 3250

!- titulky hry

40 GOSUB 2690
50 PRINT "{clear}":CH=0
60 PRINT "{home}"

!- Povoleni ke vstupu a souboje

70 GOTO 2110

!- Vypis nadpisu a textu obrazovky

80 GOSUB 2570

!- Vypis predmetu v komnate

90 GOSUB 1390

100 GOSUB 2270
110 IF GG$ = "{arrow left}" THEN 160
120 IF GG$ = "1" THEN CH=1: GOSUB 1740 :GOTO60
130 IF GG$ = "2" THEN UP=0:GOTO1580
140 IF GG$ = "3" THEN 3370
150 GOTO 190

!- Zobrazeni batohu

160 GOSUB 920
170 GOSUB 2270
180 GOTO 50

!- -----------------------------------------------------------------------------
!- test podminek, K-klavesnice, D-kostka, E-komnata=energie, R=reset hodnot
!- Pokud neni nastaveno ovladani, konec programu
!- -----------------------------------------------------------------------------

190 x$ = left$(k$(z),1)
200 if x$="k" then 330
210 if x$="d" then 260
220 if x$="e" then 250
230 if x$="r" then 2810
240 print "chyba ovladani komnaty" z:end

!- -----------------------------------------------------------------------------
!- Skok podle poctu energie. Hodnotu energie vlozi do cisla komnaty a jde dal
!- -----------------------------------------------------------------------------

250 Z = PW: goto 410

!- -----------------------------------------------------------------------------
!- Rozhodovaci volba D - Hod kostkou
!- -----------------------------------------------------------------------------

!- zobrazeni kostky vcetne oramovani a barev pomoci sikovneho PRINT figlu

260 x=0:y=35:gosub 2630:PRINT"{gray}{cm a}{sh asterisk}{sh asterisk}{sh asterisk}{cm s}{left}{down}{sh -}{left}{down}{sh -}{left}{down}{sh -}{left}{down}{cm x}{left}{left}{left}{left}{left}{up}{up}{up}{sh -}{left}{down}{sh -}{left}{down}{sh -}{left}{down}{cm z}{sh asterisk}{sh asterisk}{sh asterisk}{left}{left}{left}{up}{up}{up}";

!- nahoda

280 a=int(rnd(1)*6)+1
290 gosub 430
300 get gg$: if gg$=" " then tm=2: gosub 2650: GOTO 320
310 goto 280

!- hleda shodu cisla prevedeneho na znak s retezcem komnaty

320 GG$=CHR$(a+64)
330 KK$=K$(Z)
340 FOR I=3 TO LEN(KK$)
350 TE$=MID$(KK$,I,1)
360 IF GG$=TE$ THEN 390
370 NEXT
380 GOTO 100

!- Pokud nalezl odpovidajici hodnotu hodu a znak podminky, nacte komnatu

390 I=I+1:Z$=mid$(KK$,I,3):Z=VAL(Z$)

!- z pruchodem komnaty odpocita pripadne power down (promenna PM)

410 PW=PW-PM
420 GOTO 50

!-------------------------------------------------------------------------------
!- zobrazeni hodnoty kostky print metodou
!-------------------------------------------------------------------------------

430 x=1:y=36:gosub 2630
435 if a=1 then PRINT "{reverse on}{white} {light gray} {gray} {left}{left}{left}{down}{light gray} {gray}o{dark gray} {left}{left}{left}{down}{gray} {dark gray} {dark gray} ":RETURN
440 if a=2 then PRINT "{reverse on}{white} {light gray} {gray} {left}{left}{left}{down}{light gray}o{gray} {dark gray}o{left}{left}{left}{down}{gray} {dark gray} {dark gray} ":RETURN
450 if a=3 then PRINT "{reverse on}{white}o{light gray} {gray} {left}{left}{left}{down}{light gray} {gray}o{dark gray} {left}{left}{left}{down}{gray} {dark gray} {dark gray}o":RETURN
460 if a=4 then PRINT "{reverse on}{white}o{light gray} {gray}o{left}{left}{left}{down}{light gray} {gray} {dark gray} {left}{left}{left}{down}{gray}o{dark gray} {dark gray}o":RETURN
470 if a=5 then PRINT "{reverse on}{white}o{light gray} {gray}o{left}{left}{left}{down}{light gray} {gray}o{dark gray} {left}{left}{left}{down}{gray}o{dark gray} {dark gray}o":RETURN
480 if a=6 then PRINT "{reverse on}{white}o{light gray}o{gray}o{left}{left}{left}{down}{light gray} {gray} {dark gray} {left}{left}{left}{down}{gray}o{dark gray}o{dark gray}o":RETURN

!- vypoce potrebnych mezer do cisla

730 A$="":A=LEN(GA$):ZZ=5-A:FOR I=0 to ZZ:A$=A$+" ":NEXT:A$=A$+GA$:RETURN
750 B$="":B=LEN(GB$):ZZ=5-B:FOR I=0 to ZZ:B$=B$+" ":NEXT:B$=B$+GB$:RETURN

!- Konverze cisel do retezce

770 PW$=STR$(PW):DW$=STR$(DW):KW$=STR$(KW):RETURN

!- Prerusovana cara horni a spodni

790 FOR I=0TO19:PRINT"{brown}{cm t}{orange}{cm y}";:NEXT:RETURN
850 FOR I=0TO19:PRINT"{brown}{cm @}{orange}{cm p}";:NEXT:RETURN

!- test na obsazenost batohu

880 TE=0:FOR I=0 TO DL
890 IF B(I,0)=1 THEN TE=TE+1
900 NEXT:RETURN

!- -----------------------------------------------------------------------------
!- Vypis batohu a tabulky schopnosti
!- Promenna KX urcuje, zda zobrazovat(1) nebo nezobrazovat(0) chybejici predmety
!- -----------------------------------------------------------------------------

920 PRINT"{clear}":GOSUB790:PRINT"{light green}Obsah batohu":GOSUB850:PRINT"{return}"
930 A=0:FOR I=1 TO DL
940 IF B(I,0)=1 THEN PRINT AN$ B$(I):A=A+1
950 IF KX=1 THEN IF B(I,0) = 0 THEN PRINT NE$ B$(I):
960 NEXT
970 IF A=0 THEN PRINT "{return}{red}Batoh je prazdny{gray}"
980 gosub 770

!- Vykresleni tabulky energie, obrany a kouzel

990 a$="":a=len(pw$):zz=6-a:for i=0 to zz: a$=a$+"{reverse on} ":next:a$=a$+pw$
1000 x=0:y=23:gosub 2630: print"{light blue}{reverse on}                 "
1010 x=1:y=23:gosub 2630: print"{light blue}{reverse on} Energie "a$" "
1020 a$="": a=len(dw$): zz=6-a: for i=0 to zz: a$=a$+"{reverse on} ":next:a$=a$+dw$
1030 x=2:y=23:gosub 2630: print"{light blue}{reverse on} Obrana  "a$" "
1040 a$="": a=len(kw$): zz=6-a: for i=0 to zz: a$=a$+"{reverse on} ":next:a$=a$+kw$
1050 x=3:y=23:gosub 2630: print"{light blue}{reverse on} Kouzla  "a$" "
1060 x=4:y=23:gosub 2630: print"{light blue}{reverse on}                 "
1070 print "{reverse off}"
1080 RETURN

!- -----------------------------------------------------------------------------
!- Souboje s nepritelem
!-
!- soucet schopnosti hrac / souper = koeficient vysledku. Pokud neni koeficient
!- dostatecne :rozdilny:, opakuj vypocet dokud:
!- > 1 vyhra hrac
!- < 1 vyhra postava, skok na alternativni mistnost
!- promenna PR je pocet pruchodu souboje
!- -----------------------------------------------------------------------------

!- pokud je potvora zabita(FL=2) nebo nedefinovana(FL=0), pokracuj dale

1090 if FL(z)=2 then80
1100 if FL(z)=0 then80

!- zobrazeni tabulky souboje

1110 GOSUB790:PRINT"{white} ! " fj$(z) " ! Bojuj !":GOSUB850
1130 print "{light gray}": PRINT spc(13) "Ty" spc(9) "On"
1150 gosub 770
1160 ga$=pw$:gosub730:gb$=str$(FX(z,0)):gosub750
1170 print"{return}{light green} Energie{light blue} " a$ spc(5)b$
1180 ga$=dw$:gosub730:gb$=str$(FX(z,1)):gosub 750
1190 print"{light green} Obrana {light blue} " a$ spc(5)b$
1200 ga$=kw$: gosub 730: gb$=str$(FX(z,2)): gosub 750
1210 print"{light green} Kouzla {light blue} " a$ spc(5)b$
1220 gosub 850
1225 x=2:y=33: gosub2630:GOSUB3415

!- nastaveni sily souperu. Pocet prubehu sobouje je nahodny a bere se z 
!- casovace C64 z promenne TI$ (kde se nachazi format HHMMSS).

1230 pr = val(mid$(ti$,5,2))
1231 if pr<30 then pr=pr+60
1240 s1=pw+(dw*2)+(kw*4)
1250 s2=FX(z,0)+(FX(z,1)*2)+(FX(z,2)*4)

!- proces souboje

1260 na=int(rnd(1)*10): nb=int(rnd(1)*10):PR=PR-1
1270 s1=s1+na: s2=s2+nb

1280 x=12:y=0:gosub 2630

1290 if s1>s2 then print "{light green} Prubeh =" PR "{return}{return}{white} " jm$ s1"{return}{pink} " fj$(z) s2"{return}":POKE53280,0
1300 if s1<s2 then print "{light green} Prubeh =" PR "{return}{return}{pink} " jm$ s1"{return}{white} " fj$(z) s2"{return}":POKE53280,2
1305 IF PR>10 THEN 1260
1310 IF S1<S2 THEN 1370
1320 IF S1>S2 THEN 1350
1330 IF s1=s2 then 1230


!- vyhral jsi a stav nepritele se nastavi na mrtev (FL(index)=2)

1350 x=17:y=0:gosub2630:POKE 53280,0:GOSUB790:PRINT"{white}            !! Vyhral jsi !!":fp(z)=0:fl(z)=2:GOSUB850:gosub2270:goto50

!- prohral jsi a nasleduje skok na alternativni obrazovku

1370 x=17:y=0:gosub2630:GOSUB790:PRINT"{pink}           Byl jsi porazen...":GOSUB850:gosub2270:z=FP(z):goto50

!- -----------------------------------------------------------------------------
!- Vypis obrazovky
!-
!- XT=1 zobrazuj automaticky predmety v komnate, 0=nezobrazuj
!- BX je pole predmetu zanechane v komnate (definuje se za behu)
!- Pokud beru predmety, pricitaji se mi jejich vlastnosti.
!- -----------------------------------------------------------------------------

1390 IF LEN(BX$(Z))=1 THEN RETURN

!- Pokud exituje retezec vlastnosti, zpracuj jej a zobraz

1400 IF LEN(BB$(Z))>0 THEN gosub2290

1450 IF XT=1 THEN 1740
1460 IF XT=0 THEN RETURN

!- pricita vlastnosti predmetu ke globalnim vlastnostem

1470 MT=0
1480 FOR I=1 TO DL
1490 TX$=MID$(BX$(Z),I,1)
1500 IF TX$="+" THEN B(I,0)=1:PW=PW+B(I,1):DW=DW+B(I,2):KW=KW+B(I,3)
1510 NEXT I
1520 BX$(Z)=BD$

!- Test na preplneny batoh. Pokladani predmetu

1530 FOR I=1 TO DL
1540 IF B(I,0)=1 THEN MT=MT+1
1550 NEXT 
1560 IF MT>MX THEN UP=1:GOTO1580
1570 RETURN

!- pokladani predmetu Pokud prisel povel od klavesy 2 zobrazi se jiny text 
!- nez kdyz je preplneny batoh. (promenna UP)

1580 GOSUB 880: IF TE=0 THEN 2080
1590 PRINT "{clear}": GOSUB790
1600 IF UP=1 THEN PRINT "{pink}Mas toho moc " jo$ ". Neco odloz!{gray}"
1601 IF UP=0 THEN PRINT "{light green}Vyber predmety, ktere zde polozis.{gray}"
1610 GOSUB850:PRINT"{return}"

!- V pripade, ze chci polozit predmet do mistnosti, kde neni definovan retezec,
!- musim jej nejdrive definovat.

1620 gg=len(bx$(z)): if gg=0 then bx$(z)=bd$

1630 K=0:FOR I=1 TO DL
1640 IF B(I,0)=1 THEN PRINT "{white}"CHR$(I+64)"{purple}" SPC(4) B$(I):KP$(K)=CHR$(I+64)
1650 IF B(I,0)=1 THEN KP(K)=I
1660 IF B(I,0)=1 THEN K=K+1
1670 NEXT I 
1680 IF UP=0 THEN PRINT "{return}": GOSUB 790:print"{light green}Klavesou space se vratis{gray}":GOSUB850
1681 IF UP=1 THEN PRINT"{return}":GOSUB850
1690 GOSUB 2270
1700 GOTO 1940

!- -----------------------------------------------------------------------------
!- vypise koncovku podle poctu
!- -----------------------------------------------------------------------------

1710 if MT<2 THEN PRINT "";:RETURN
1720 if MT<5 THEN PRINT "y";:RETURN
1730 if MT>4 THEN PRINT "u";:RETURN

!- -----------------------------------------------------------------------------
!- Vypis nalezenych predmetu a mrtvych nepratel (FP)
!- Predmety, ktere se maji odebrat se automaticky odeberou
!- -----------------------------------------------------------------------------

1740 MT=0
1750 IF FL(Z)=2 THEN PRINT"{return}{red}Na zemi se nachazi mrtvy " FJ$(Z)
1760 FOR I=1 TO DL
1770 TX$=MID$(BX$(Z),I,1)
1780 IF TX$="+" THEN MT=MT+1
1790 NEXT I
1800 IF MT>0 THEN PRINT "{light green}{return}Nasel jsi" MT "predmet";: GOSUB1710:PRINT"{return}":GOTO1820
1810 PRINT "{return}{red}" NI$:RETURN
1820 MT=0
1830 FOR I=1 TO DL
1840 TX$=MID$(BX$(Z),I,1)
1850 IF TX$="+" THEN MT=MT+1:PRINT"{white}+{cyan} " B$(I) "{gray}"
1860 IF B(I,0)=1 THEN IF TX$="-" THEN PRINT"{white}-{cyan} " B$(I) "{gray}":B(I,0)=0
1870 NEXT I
1880 IF MT=0 THEN RETURN
1890 PRINT"{return}{gray}Vzit predmet";:GOSUB1710:PRINT" ?"
1900 GOSUB2270
1910 IF GG$=QY$ THEN PRINT"{clear}":GOSUB2570:GOTO1470
1920 IF GG$=QN$ THEN PRINT "{clear}":GOSUB2570:RETURN
1930 GOTO1900

!- -----------------------------------------------------------------------------
!- Pokladani predmetu
!- Pokud prisel povel z preplneneho batohu (UP=1), cekej na stisk a opakuj
!- -----------------------------------------------------------------------------

1940 FOR I=0 TO K
1950 IF GG$=KP$(I) THEN1980
1960 NEXT I
1970 IF UP=0 THEN PRINT"{clear}": GOTO 80
1975 IF UP=1 THEN GOSUB2270:GOTO1940
1980 FOR A=1 TO DL
1990 AA=A-1

!- odecet schopnosti odkladanych predmetu

2000 IF A=KP(I) THEN BF$(AA)="+":PW=PW-B(A,1):DW=DW-B(A,2):KW=KW-B(A,3)
2010 IF A<>KP(I)THEN BF$(AA)=MID$(BX$(Z),A,1)
2020 NEXT A
2030 ST$=""
2040 FOR A=0 TO 11: ST$=ST$+BF$(A): NEXT
2050 BX$(Z)=ST$
2060 B(KP(I),0)=0
2070 GOTO 50
2080 PRINT "{red}{return}Nenalezeno nic k odlozeni{gray}"
2090 GOSUB 2270
2100 GOTO 50

!- -----------------------------------------------------------------------------
!- Test potrebnych predmetu pri vstupu do komnaty
!- Pokud je TE(pocet chybejicich veci) vetsi nez 0, pouzij alter.stranku v T
!- -----------------------------------------------------------------------------

2110 TE=0
2120 FOR I=1 TO DL
2130 TS$=MID$(T$(Z),I,1)
2140 TB$=STR$(B(I,0))
2150 TS$=" "+TS$
2160 IF TS$=" +" THEN 2180
2170 GOTO 2200
2180 IF TB$=" 1" THEN 2200
2190 TE=TE+1:TN(TE)=I
2200 NEXT I

!- pokud mam vsechny potrebne predmety, pokracuj na test boje s nepritelem

2205 IF TE=0 THEN 1090

!- chybi predmety, vstup nepovolen, pokracuj na altern.komnatu (promenna T do Z)

2210 GOSUB790:PRINT"{light green}Chybi ti nasledujici predmety{gray}": GOSUB850:PRINT"{pink}"
2220 for A=1 TO DL: IF TN(A)>0 then print B$(TN(A)): NEXT A
2230 GOSUB850
2240 GET GG$:IF GG$="" THEN2240
2250 Z=T(Z):GOTO50

!- -----------------------------------------------------------------------------
!- cekani na stisk klavesy
!- -----------------------------------------------------------------------------

2270 GET GG$: IF GG$ = "" THEN 2270
2280 RETURN

!- -----------------------------------------------------------------------------
!- Vlastnosti ziskane pri vstupu
!- Zkontroluju ,zdali se jiz energie v komnate nesebrala (BC(Z))
!- -----------------------------------------------------------------------------

2290 if BC(z)=1 then2560: IF BB$(Z)="" then 2560
2300 if left$(BB$(z),1)="+" then gg=val(mid$(BB$(z),2,3)):goto2400
2310 if left$(BB$(z),1)="-" then gg=val(mid$(BB$(z),2,3)):goto2420
2320 if mid$(BB$(z),6,1)="+" then gg=val(mid$(BB$(z),7,3)):goto2440
2330 if mid$(BB$(z),6,1)="-" then gg=val(mid$(BB$(z),7,3)):goto2460
2340 if mid$(BB$(z),11,1)="+" then gg=val(mid$(BB$(z),12,3)):goto2480
2350 if mid$(BB$(z),11,1)="-" then gg=val(mid$(BB$(z),12,3)):goto2500
2360 if left$(BB$(z),1)="*" then gg=val(mid$(BB$(z),2,3)):goto2520
2370 if mid$(BB$(z),6,1)="*" then gg=val(mid$(BB$(z),7,3)):goto2530
2380 if mid$(BB$(z),11,1)="*" then gg=val(mid$(BB$(z),12,3)):goto2540
2390 goto2550

2400 if gg>0 then print"{white}+{green}" gg "energie": pw=pw+gg:goto2320
2410 goto 2320
2420 if gg>0 then print"{pink}-{pink}" gg "energie": pw=pw-gg:goto2320
2430 goto 2320
2440 if gg>0 then print"{white}+{green}" gg "obrana": dw=dw+gg:goto2340
2450 goto 2340
2460 if gg>0 then print"{pink}-{pink}" gg "obrana": dw=dw-gg:goto2340
2470 goto 2340
2480 if gg>0 then print"{white}+{green}" gg "kouzla": kw=kw+gg:goto2360
2490 goto 2360
2500 if gg>0 then print"{pink}-{pink}" gg "kouzla": kw=kw-gg:goto2360
2510 goto 2360

2520 pw = gg: print "{light green}energie =" pw: goto 2370
2530 dw = gg: print "obrana  =" dw: goto 2380
2540 kw = gg: print "kouzla  =" kw

!- smazu po sobe pole energie. Muze byt problem pokud se chce hra znova
!- spustit. Pak nenajde tato pole. Bylo by lepsi si uchovavat prolezene
!- komnaty do jineho pole a testovat, zdali jiz byly prolezeny.

2550 BC(z)=1
2560 return

!- -----------------------------------------------------------------------------
!- vypis nadpisu a textu
!- -----------------------------------------------------------------------------

2570 GOSUB790:PRINT"{yellow}" N$(Z)"{gray}": GOSUB850: print"{return}"
2580 IF PA(Z)>0 THEN for i=0to5:if len(p$(PA(Z),i)) > 0 then print"{gray}" P$(PA(Z),I);:NEXT
2590 IF PA(Z)>0 THEN print"{return}":RETURN

2600 for i=0to5:if len(p$(z,i))>0 then print"{gray}" P$(Z,I);:NEXT
2610 print"{return}"
2620 RETURN

!- -----------------------------------------------------------------------------
!- umistneni vypisu na obrazovku
!- -----------------------------------------------------------------------------

2630 POKE 781,x:POKE 782,y:POKE 783,0:SYS 65520
2640 return

!- casovac - timer

2650 gg=ti+(tm*60)
2660 if ti>gg then return
2670 goto2660
2680 return

!- -----------------------------------------------------------------------------
!- Zacatecni titulky ke hre
!- -----------------------------------------------------------------------------

2690 PRINT "{clear}"
2691 x=9:y=0: gosub2630:PRINT "{reverse on}{blue}  {right}{right}  {light blue}{right}  {right}{right}  {right}{white}     {right}{right}      {right}{light blue}{right}    {right}{right}{blue}  ";
2692 x=10:y=0:gosub2630:PRINT "{blue}  {right}{right}  {light blue}{right}   {right}  {right}{white}  {right}{right}  {right}  {right}{right}{right}{right}{right}{light blue}  {right}{right}  {right}{blue}  ";
2693 x=11:y=0:gosub2630:PRINT "{blue}  {right}{right}  {light blue}{right}      {right}{white}     {right}{right}   {right}{right}{right}{right}{light blue}      {right}{blue}  ";
2694 x=12:y=0:gosub2630:PRINT "{blue}  {right}{right}  {light blue}{right}  {right}   {right}{white}  {right}{right}  {right}  {right}{right}{right}{right}{right}{light blue}  {right}{right}  {right}{blue}  ";
2695 x=13:y=0:gosub2630:PRINT "{blue}  {right}{right}  {light blue}{right}  {right}{right}  {right}{white}  {right}{right}  {right}  {right}{right}{right}{right}{right}{light blue}  {right}{right}  {right}{blue}  ";
2696 x=14:y=0:gosub2630:PRINT "{blue}{right}    {right}{light blue}{right}  {right}{right}  {right}{white}  {right}{right}  {right}      {right}{light blue}  {right}{right}  {right}{blue}     "
2697 tm=3:gosub2650:POKE 53280,1:poke53281,1
2700 x=9:y=2: gosub2630
2701 PRINT "{dark gray}{cm f}{left}{down}{cm k}{left}{down}{cm k}{left}{down}{cm k}{left}{down}{cm k}{left}{left}{down}{down}{cm c}{reverse on}{cm i}{cm i}{cm i}{reverse off}{cm v}{left}{up}{reverse on}{cm d}{reverse off}{cm v}{left}{up}{cm k}{left}{up}{cm k}{left}{up}{cm k}{left}{up}{cm k}{left}{up}{cm f}";
2702 PRINT "{down}{down}{down}{right}{right}{reverse on}{cm d}{reverse off}{down}{cm c}{left}{left}{cm k}{left}{down}{cm k}{left}{left}{left}{down}{cm c}{reverse on}{cm i}{reverse off}{cm v}{right}{cm c}{reverse on}{cm i}{reverse off}{cm v}{left}{up}{cm k}{left}{up}{cm k}{left}{up}{cm k}{left}{up}{cm k}{left}{up}{cm k}{left}{up}{cm f}";
2703 PRINT "{right}{right}{down}{reverse on}{cm i}{cm i}{reverse off}{right}{up}{cm f}{down}{cm f}{left}{left}{down}{reverse on}{cm d}{reverse off}{cm v}{left}{left}{left}{left}{left}{down}{cm k}{left}{down}{cm k}{left}{down}{cm k}{left}{left}{left}{down}{cm c}{reverse on}{cm i}{reverse off}{cm v}{right}{cm c}{reverse on}{cm i}{reverse off}{cm v}{left}{up}{cm k}{left}{up}{cm k}{left}{up}{cm f}";
2704 PRINT "{up}{up}{right}{right}{reverse on}{cm d}{cm i}{cm i}{cm i}{reverse off}{cm v}{left}{up}{cm f}{left}{left}{left}{left}{down}{down}{cm f}{left}{left}{down}{reverse on}{cm d}{reverse off}{cm v}{left}{left}{down}{cm k}{left}{left}{left}{down}{down}{cm c}{reverse on}{cm i}{cm i}{cm i}{cm i}{cm i}{reverse off}{cm v}{left}{up}{cm f}";
2705 PRINT "{down}{cm c}{reverse on}{cm i}{reverse off}{cm v}{left}{up}{cm k}{left}{up}{cm k}{left}{up}{reverse on}{cm d}{cm i}{left}{left}{up}{up}{cm i}{cm i}{up}{right}{reverse off}{cm f}{down}{cm f}{left}{down}{cm k}{left}{down}{cm k}{left}{down}{cm k}{left}{down}{cm k}{left}{left}{left}{down}{cm c}{reverse on}{cm i}{reverse off}{cm v}";
2706 PRINT "{cm c}{reverse on}{cm i}{cm i}{cm i}{cm i}{reverse off}{left}{left}{left}{up}{up}{up}{up}{up}{up}{cm f}{left}{down}{cm k}{left}{down}{cm k}{left}{down}{cm k}{left}{down}{cm k}"
2707 x=16:y=0:gosub2630:PRINT "{gray}Since 1995"
2790 POKE53280,0:POKE53281,0
2795 tm=4:gosub2650
2800 RETURN

!- vymazani poli pro novou hru

2810 gosub2690:sys64738


!- -----------------------------------------------------------------------------
!- Definice hernich promennych
!-
!- Z = cislo komnaty
!- jm$ = jmeno hrace, jo$=osloveni hrace
!- DL = hodnota poctu veci v batohu
!- PG = pocet definovanych komnat
!- MX = maximalni pocet veci v invntari (testuje se za behu v promenne MT)
!- PM = Kolik se ma odecist energie na kazde obrazovce
!- PW,DW,KW = Nastaveni Energie,Obrany a kouzel
!- Z = Startovaci obrazovka
!- NM$ = Nazev hry
!- BD$ = batoh odpovidajici poctu veci v batohu
!- BF$ = bafr poctu predmetu
!- XT = 0=Nebrat automaticky predmety v obrazovce, 1-brat predmety
!- KX = 1=zobrazovat predmety ktere nemam, 0= nezobrazovat
!- -----------------------------------------------------------------------------

2840 DL=12:PG=87:DW=0:Z=0:KX=1:MX=3:PW=0:PM=0:KW=0:XT=0
2850 NM$="-- Prvni ukazkova hra --"
2860 AN$="{white}"+CHR$(186)+"{gray} "
2870 NE$="{red}x{gray} "
2880 BD$="............"
2890 QY$="a": QN$="n"
2900 NI$="{light green}Zadny predmet se zde nenachazi{gray}"

2940 POKE53280,0:POKE53281,0:POKE646,15:POKE53272,23:POKE650,64:POKE649,1
2950 POKE657,128:POKE808,234

!- misto pro definice retezcu, ktere se pouzivaji opakovane
!- kazda optimalizace setri misto v pameti!

2960 SL$(0)="{return}{return}{white}(space){gray}"

!- -----------------------------------------------------------------------------
!- definice batohu a predmetu v poradi
!- -----------------------------------------------------------------------------
!- B(index,0) = 0=predmet nemam, 1=predmet mam
!- B(index,1) = PW sila power  predmetu
!- B(index,2) = DW sila obrany predmetu
!- B(index,3) = KW sila kouzla predmetu
!-
!- Pozor. Pri pocatecnim nastaveni predmetu se nepricitaji jeho hodnoty
!- k celkovym hodnotam! Pri sbirani a pokladani jiz ano.
!- -----------------------------------------------------------------------------

2970 DIM B(DL,3): DIM B$(DL): DIM TN(DL)
2980 B$(0)="----"
2990 B$(1)="lano"
3000 B$(2)="sirky"
3010 B$(3)="leva pulka mapy"
3020 B$(4)="prava pulka mapy"
3030 B$(5)="prazdna lahev"
3040 B$(6)="lahev s vodou"
3050 B$(7)="nuz"
3060 B$(8)="tuzka"
3070 B$(9)="pistol"
3080 B$(10)="sekera"
3090 B$(11)="vlajka"
3100 B$(12)="mapa cela"

3120 B(0,0)=0:B(0,1)=0:B(0,2)=0:B(0,3)=0
3130 B(1,0)=0:B(1,1)=2:B(1,2)=2:B(1,3)=0
3140 B(2,0)=0:B(2,1)=5:B(2,2)=0:B(2,3)=0
3150 B(3,0)=0:B(3,1)=0:B(3,2)=0:B(3,3)=2
3160 B(4,0)=0:B(4,1)=0:B(4,2)=0:B(4,3)=2
3170 B(5,0)=0:B(5,1)=0:B(5,2)=0:B(5,3)=0
3180 B(6,0)=0:B(6,1)=0:B(6,2)=3:B(6,3)=0
3190 B(7,0)=0:B(7,1)=10:B(7,2)=0:B(7,3)=0
3200 B(8,0)=0:B(8,1)=3:B(8,2)=0:B(8,3)=5
3210 B(9,0)=0:B(9,1)=25:B(9,2)=10:B(9,3)=0
3220 B(10,0)=0:B(10,1)=15:B(10,2)=5:B(10,3)=0
3230 B(11,0)=0:B(11,1)=0:B(11,2)=0:B(11,3)=10
3235 B(12,0)=0:B(12,1)=15:B(12,2)=0:B(12,3)=0

3240 RETURN

!- -----------------------------------------------------------------------------
!- Uvodni obrazovka Basic Game Engine
!- -----------------------------------------------------------------------------

3250 PRINT"{clear}":GOSUB790:PRINT"  {white}Basic Game Engine V1.1 by Petr Chlud{gray}{return}{return}"
3260 def fn center(x)=(40-x)/2
3270 gg=len(NM$)
3280 x=4:y=fn center(gg):gosub2630:PRINT "{light green}" NM$
3290 GOSUB850: INPUT "{return}{gray}Zadej sve jmeno {white}";jm$
3300 INPUT"{up}{gray}Zadej osloveni  {white}";jo$
3310 PRINT"{return}{light green}Zdravim te " JO$ ",{return}{return}Klavesy, ktere muzes kdykoliv pouzit.{return}"
3319 PRINT"{white}{arrow left}{gray} - Zobrazeni batohu"
3320 PRINT"{white}1{gray} - Prozkoumat okoli{return}{white}2{gray} - Polozeni predmetu{return}";
3330 PRINT"{white}3{gray} - Seznam porazenych nepratel{return}"
3340 PRINT"Tvoris-li hru, nemapuj na ne podminky." SL$(0):GOSUB850
3350 GOSUB2270
3360 RETURN

!- -----------------------------------------------------------------------------
!- Zobrazeni zneskodnenych nepratel
!- -----------------------------------------------------------------------------

3370 PRINT"{clear}":GOSUB790:PRINT "{red}Seznam porazenych nepratel":GOSUB850:PRINT"{return}":A1=0
3380 FOR A=1 TO PG
3390 IF FL(A)=2 THEN PRINT"{gray}" FJ$(A);:PRINT"{red} - mrtev{return}":A1=A1+1
3400 NEXTA
3405 IF A1=0 THEN PRINT "{pink}Zatim jsi toho moc neporazil."
3406 x=0:y=32: gosub2630:GOSUB3415
3407 x=10:y=28: gosub2630:GOSUB3415
3410 GOSUB2270:GOTO50

!- kresleni lebky

3415 PRINT "{red}{reverse on}{cm v}   {cm c}{left}{left}{left}{left}{left}{left}{down}       {left}{left}{left}{left}{left}{left}{left}{down} {reverse off}{cm t}{cm u}{reverse on} {reverse off}{cm u}{cm t}{reverse on} {left}{left}{left}{left}{left}{left}{left}{down}";
3417 PRINT " {reverse off} {white}{cm v}{red}{reverse on} {reverse off}{white}{cm c}{red} {reverse on} {left}{left}{left}{left}{left}{left}{left}{down}   {cm i}   {left}{left}{left}{left}{left}{left}{down}{cm g} {cm u} {cm l}{left}{left}{left}{left}{left}{down} {cm d}{cm d}{cm d} {left}{left}{left}{left}{down}   "
3419 RETURN

!- -----------------------------------------------------------------------------
!- Definice jednotlivych obrazovek
!-
!- N$  = nadpis obrazovky
!- P$  = Text obrazovky
!- PA  = Nacteni alternativniho textu z jine stranky PA(stranka)
!- K$  = Volba ovladani mistonost ve formatu X/A???/B???/C... kde :
!-       X = K = Ceka na klavesy
!-       X = D = Ceka na hod kostkou
!- G   = pole hodnot, ktere odpovidaji klavesam v poradi
!- BX$ = Predmety, ktere nachazi hrac na obrazovce. Pokud neni definovano a
!-       hrac predmet do takove komnaty polozi, vytvori se za behu.
!- T$  = Test, zda-li ma hrac potrebne predmety. Pokud ano, pokracuje se dale.
!-       Pokud ne, T = alternativni skok na obrazovku
!- TN  = pole chybejicich predmetu ve formatu (index, index predmetu)
!- BB$ = Hodnota Energie, Utoku, Obrany a Kouzla pri vstupu do obrazovky
!-       Muze byt i do minusu ve formatu "+010/+000/-005"
!-       Natvrdo nastaveni hodnot pomoci * "*010/*008/*003"
!- BC  = 0 - jeste nevybrano, 1 - vybrano
!-       Ukazatel se meni behem hry a na zacatku nove hry musi byt vynulovan
!-       A je tu proto aby se energia a spol vzali pouze jednou.
!- FJ$ = Nazev nepritele
!- FX (obr,co) co = Nepritel a jeho Energie, Utok, Obrana a Utok
!- FP  = Skok na stranku po prohranem souboj
!- FL  = 1 nepritel zivy, 2 nepritel mrtvy
!- -----------------------------------------------------------------------------

3420 DIM n$(PG):DIM p$(PG,5):DIM k$(PG):DIM BX$(PG):DIM t$(PG)
3430 DIM t(PG):DIM BB$(PG):DIM BC(PG):DIM FX(PG,2):DIM FP(PG):DIM FL(PG)
3440 DIM BX(PG,3):DIM FJ$(PG):DIM BF$(DL):DIM KP$(DL):DIM KP(DL)

3450 N$(0)="Hra zacina! Predmety..."
3460 P$(0,0)="Na zacatku obdrzim energii a obranu.{return}Predmety musim nalezt pomoci klavesy {white}1{gray}.{return}"
3470 P$(0,1)="Klavesou {white}{arrow left}{gray} se zobrazi batoh.{return}Pokracovat lze stiskem klavesy {white}p{gray}"
3480 BX$(0) = "++.+...+...."
3490 BB$(0) = "+010/+002/+000"
3500 K$(0)="k/p001"

3510 N$(1)="1. Komnata"
3520 P$(1,0)="Do teto komnaty se dostanu pouze mam-li vsechny potrebne predmety."+SL$(0)
3530 T$(1) = "++.........."
3540 T(1)=0
3550 K$(1)="k/ 002"

3560 N$(2)="{white}2. Porazils Krakena"
3570 P$(2,0)="{gray}Pokud vidis tento text, jsi zivy{return}a porazil jsi Krakena.{return}Zkus prohledat mistnost klavesou {white}1{gray}"+SL$(0)
3580 K$(2)="k/ 004"
3590 FL(2)=1:FJ$(2)="Kraken":FX(2,0)=17:FX(2,1)=4:FX(2,2)=0: FP(2)=1

3600 N$(3)="3. Komnata po kostce"
3610 P$(3,0)="Vsechny hody z komnaty c.4 jsou presmerovany na tuto stranku, kde si ukazeme moznosti vice podminek."
3611 P$(3,1)="Muzes jit na {white}z{gray}acatekhry, ke {white}K{gray}rakenovi, {white}h{gray}azet kostkou nebo{return}{white}p{gray}okracovat dale."
3620 K$(3)="k/z000/k002/h004/p005"

3630 N$(4)="Tato stranka nacita text z jine stranky"
3640 PA(4)= 1
3650 K$(4)="d/a003/b003/c003/d003/e003/f003"

3660 N$(5)="Jste na konci hry :)"
3670 P$(5,0) = "Gratulujeme!{return}Prave jste prosli svoji prvni hru{return}vytvorenou pomoci programu {return}{return}{light blue}Basic Text Game Engine v2.0"+SL$(0)
3680 K$(5)="r"

!- konec musi obsahovat RETURN, protoze promenne se nacitaji pomoci GOSUB

10000 RETURN